{ PDP-11 command execution,
  based on the PDP-11/03 emulator written by Ovsienko V.A. }

unit make_mk;


interface

  function Make_TRAP10 : pointer;	{ XXXXXXX ----    TRAP10   ------ }
  function Make_BR : pointer;		{ 0004XXX ----    BR      ------ }
  function Make_BNE : pointer;		{ 0010XXX ----    BNE     ------ }
  function Make_BEQ : pointer;		{ 0014XXX ----    BEQ     ------ }
  function Make_BVC : pointer;		{ 1020XXX ----    BVC     ------ }
  function Make_BVS : pointer;		{ 1024XXX ----    BVS     ------ }
  function Make_BCC : pointer;		{ 1030XXX ----    BCC     ------ }
  function Make_BCS : pointer;		{ 1034XXX ----    BCS     ------ }
  function Make_BGE : pointer;		{ 0020XXX ----    BGE     ------ }
  function Make_BLT : pointer;		{ 0024XXX ----    BLT     ------ }
  function Make_BGT : pointer;		{ 0030XXX ----    BGT     ------ }
  function Make_BLE : pointer;		{ 0034XXX ----    BLE     ------ }
  function Make_BPL : pointer;		{ 1000XXX ----    BPL     ------ }
  function Make_BMI : pointer;		{ 1004XXX ----    BMI     ------ }
  function Make_BHI : pointer;		{ 1010XXX ----    BHI     ------ }
  function Make_BLOS : pointer;		{ 1014XXX ----    BLOS    ------ }
  function Make_JSR : pointer;		{ 004RDD  ----    JSR     ------ }
  function Make_MOV : pointer;		{ 01SSDD  ++0-    MOV     ------ }
  function Make_CMP : pointer;		{ 02SSDD  ++++    CMP     ------ }
  function Make_BIT : pointer;		{ 03SSDD  ++0-    BIT     ------ }
  function Make_BIC : pointer;		{ 04SSDD  ++0-    BIC     ------ }
  function Make_BIS : pointer;		{ 05SSDD  ++0-    BIS     ------ }
  function Make_ADD : pointer;		{ 06SSDD  ++++    ADD     ------ }
  function Make_MUL : pointer;		{ 070RSS  ++0+    MUL     ------ }
  function Make_DIV : pointer;		{ 071RSS  ++++    DIV     ------ }
  function Make_ASH : pointer;		{ 072RSS  ++++    ASH     ------ }
  function Make_ASHC : pointer;		{ 073RSS  ++++    ASHC    ------ }
  function Make_XOR : pointer;		{ 074RDD  ++0-    XOR     ------ }
  function Make_SOB : pointer;		{ 077RNN  ----    SOB     ------ }
  function Make_EMT : pointer;		{ 1040XXX ++++    EMT     ------ }
  function Make_TRAP : pointer;		{ 1044XXX ++++    TRAP    ------ }
  function Make_MOVB : pointer;		{ 11SSDD  ++0-    MOVB    ------ }
  function Make_CMPB : pointer;		{ 12SSDD  ++++    CMPB    ------ }
  function Make_BITB : pointer;		{ 13SSDD  ++0-    BITB    ------ }
  function Make_BICB : pointer;		{ 14SSDD  ++0-    BICB    ------ }
  function Make_BISB : pointer;		{ 15SSDD  ++0-    BISB    ------ }
  function Make_SUB : pointer;		{ 16SSDD  ++++    SUB     ------ }
  function Make_HALT : pointer;		{ 000000  ----    HALT    ------ }
  function Make_WAIT : pointer;		{ 000001  ----    WAIT    ------ }
  function Make_RTI : pointer;		{ 000002  ++++    RTI     ------ }
  function Make_BPT : pointer;		{ 000003  ++++    BPT     ------ }
  function Make_IOT : pointer;		{ 000004  ++++    IOT     ------ }
  function Make_RESET : pointer;	{ 000005  0000    RESET   ------ }
  function Make_RTT : pointer;		{ 000006  ++++    RTT     ------ }
  function Make_MFPT : pointer;		{ 000007  ----    MFPT    ------ }
  function Make_RTI12 : pointer;	{ 000012  ++++    RTI12   ------ }
  function Make_JMP : pointer;		{ 0001SS  ----    JMP     ------ }
  function Make_RTS : pointer;		{ 00020R  ----    RTS     ------ }
  function Make_CLC : pointer;		{ 00024C  ++++    CLC     ------ }
  function Make_SEC : pointer;		{ 00026C  ++++    SEC     ------ }
  function Make_SWAB : pointer;		{ 0003DD  ++00    SWAB    ------ }
  function Make_CLR : pointer;		{ 0050DD  0100    CLR     ------ }
  function Make_COM : pointer;		{ 0051DD  ++01    COM     ------ }
  function Make_INC : pointer;		{ 0052DD  +++-    INC     ------ }
  function Make_DEC : pointer;		{ 0053DD  +++-    DEC     ------ }
  function Make_NEG : pointer;		{ 0054DD  ++++    NEG     ------ }
  function Make_ADC : pointer;		{ 0055DD  ++++    ADC     ------ }
  function Make_SBC : pointer;		{ 0056DD  ++++    SBC     ------ }
  function Make_TST : pointer;		{ 0057DD  ++00    TST     ------ }
  function Make_ROR : pointer;		{ 0060DD  ++++    ROR     ------ }
  function Make_ROL : pointer;		{ 0061DD  ++++    ROL     ------ }
  function Make_ASR : pointer;		{ 0062DD  ++++    ASR     ------ }
  function Make_ASL : pointer;		{ 0063DD  ++++    ASL     ------ }
  function Make_MARK : pointer;		{ 0064NN  ----    MARK    ------ }
  function Make_SXT : pointer;		{ 0067DD  ?+?-    SXT     ------ }
  function Make_CLRB : pointer;		{ 1050DD  0100    CLRB    ------ }
  function Make_COMB : pointer;		{ 1051DD  ++01    COMB    ------ }
  function Make_INCB : pointer;		{ 1052DD  +++-    INCB    ------ }
  function Make_DECB : pointer;		{ 1053DD  +++-    DECB    ------ }
  function Make_NEGB : pointer;		{ 1054DD  ++++    NEGB    ------ }
  function Make_ADCB : pointer;		{ 1055DD  ++++    ADCB    ------ }
  function Make_SBCB : pointer;		{ 1056DD  ++++    SBCB    ------ }
  function Make_TSTB : pointer;		{ 1057DD  ++00    TSTB    ------ }
  function Make_RORB : pointer;		{ 1060DD  ++++    RORB    ------ }
  function Make_ROLB : pointer;		{ 1061DD  ++++    ROLB    ------ }
  function Make_ASRB : pointer;		{ 1062DD  ++++    ASRB    ------ }
  function Make_ASLB : pointer;		{ 1063DD  ++++    ASLB    ------ }
  function Make_MTPS : pointer;		{ 1064SS  ++++    MTPS    ------ }
  function Make_MFPS : pointer;		{ 1067DD  ----    MFPS    ------ }


implementation

  uses make_def, srcdst;


{ calculate the N and Z bits for value A }
  procedure Check_bit_NZ (A: integer);
  begin
    if A<0 then psw := psw or N_bit
    else if A = 0 then psw := psw or Z_bit;
  end {Check_bit_NZ};


{ calculate the V bit for shifts/rotations, V = N xor C }
  procedure NCtoV;
  begin
    psw := psw or (((psw shr 2) xor (psw shl 1)) and V_bit);
  end;


{ all command execution functions return nil when no errors occured,
  otherwise a pointer to a trap vector in the ROM }

  function Make_TRAP10 : pointer;	{ XXXXXXX ----    TRAP10   ------ }
  begin
    Make_TRAP10 := @rom[$0008];
  end {Make_TRAP10};


  function Make_BR : pointer;		{ 0004XXX ----    BR      ------ }
  var
    offset: word;
  begin
    offset := Lo(code);
    if (offset and $80) <> 0 then offset := offset or $FF00;
    ptrw(@reg[R7])^ := ptrw(@reg[R7])^ + (offset shl 1);
    Make_BR := nil;
  end {Make_BR};


  function Make_BNE : pointer;		{ 0010XXX ----    BNE     ------ }
  begin
    if (psw and Z_bit) = 0 then Make_BNE := Make_BR else Make_BNE := nil;
  end {Make_BNE};


  function Make_BEQ : pointer;		{ 0014XXX ----    BEQ     ------ }
  begin
    if (psw and Z_bit) <> 0 then Make_BEQ := Make_BR else Make_BEQ := nil;
  end {Make_BEQ};


  function Make_BVC : pointer;		{ 1020XXX ----    BVC     ------ }
  begin
    if (psw and V_bit) = 0 then Make_BVC := Make_BR else Make_BVC := nil;
  end {Make_BVC};


  function Make_BVS : pointer;		{ 1024XXX ----    BVS     ------ }
  begin
    if (psw and V_bit) <> 0 then Make_BVS := Make_BR else Make_BVS := nil;
  end {Make_BVS};


  function Make_BCC : pointer;		{ 1030XXX ----    BCC     ------ }
  begin
    if (psw and C_bit) = 0 then Make_BCC := Make_BR else Make_BCC := nil;
  end {Make_BCC};


  function Make_BCS : pointer;		{ 1034XXX ----    BCS     ------ }
  begin
    if (psw and C_bit) <> 0 then Make_BCS := Make_BR else Make_BCS := nil;
  end {Make_BCS};


  function Make_BGE : pointer;		{ 0020XXX ----    BGE     ------ }
  begin
    if (((psw shr 2) xor psw) and V_bit) = 0 then Make_BGE := Make_BR
    else Make_BGE := nil;
  end {Make_BGE};


  function Make_BLT : pointer;		{ 0024XXX ----    BLT     ------ }
  begin
    if (((psw shr 2) xor psw) and V_bit) <> 0 then Make_BLT := Make_BR
    else Make_BLT := nil;
  end {Make_BLT};


  function Make_BGT : pointer;		{ 0030XXX ----    BGT     ------ }
  begin
    if (psw and Z_bit) = 0 then Make_BGT := Make_BGE else Make_BGT := nil;
  end {Make_BGT};


  function Make_BLE : pointer;		{ 0034XXX ----    BLE     ------ }
  begin
    if (psw and Z_bit) <> 0 then Make_BLE := Make_BR
    else Make_BLE := Make_BLT;
  end {Make_BLE};


  function Make_BPL : pointer;		{ 1000XXX ----    BPL     ------ }
  begin
    if (psw and N_bit) = 0 then Make_BPL := Make_BR else Make_BPL := nil;
  end {Make_BPL};


  function Make_BMI : pointer;		{ 1004XXX ----    BMI     ------ }
  begin
    if (psw and N_bit) <> 0 then Make_BMI := Make_BR else Make_BMI := nil;
  end {Make_BMI};


  function Make_BHI : pointer;		{ 1010XXX ----    BHI     ------ }
  begin
    if (psw and Z_bit) = 0 then Make_BHI := Make_BCC else Make_BHI := nil;
  end {Make_BHI};


  function Make_BLOS : pointer;		{ 1014XXX ----    BLOS    ------ }
  begin
    if (psw and Z_bit) <> 0 then Make_BLOS := Make_BR
    else Make_BLOS := Make_BCS;
  end {Make_BLOS};


  function Make_JSR : pointer;		{ 004RDD  ----    JSR     ------ }
  var
    R, temp: word;
  begin
{ The destination of jsr must not be a register, i.e. the address mode must
  not equal zero. If it does, a trap at 10 occurs. }
    if (code and $38) = 0 then Make_JSR := @rom[$0008] else
    begin
      R := (code shr 5) and $E; 		{ index of the R register }
      dummyptr := GetSrcW(code and $3F);
      temp := loc;				{ temp <- EA }
{ here should go the 'loc' range check }
      dummyptr := GetSrcW($26);         	{ SP <- SP-2, stack <- SP }
{ here should go the 'loc' range check }
      ptrw(DstPtr)^ := ptrw(@reg[R])^;		{ (SP) <- R }
      ptrw(@reg[R])^ := ptrw(@reg[R7])^;	{ R <- PC }
      ptrw(@reg[R7])^ := temp;			{ PC <- temp }
      Make_JSR := nil;
    end;
  end {Make_JSR};


  function Make_MOV : pointer;		{ 01SSDD  ++0-    MOV     ------ }
  var
    SRC, DST: ptrw;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := SRC^;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(smallint(DST^)));
    Make_MOV := nil;
  end {Make_MOV};


  function Make_CMP : pointer;		{ 02SSDD  ++++    CMP     ------ }
  var
    SRC, DST: ptrw;
    x, y: word;
  begin
{ different order from SUB! }
    DST := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    SRC := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ - SRC^;
    y := (x and SRC^) or ((not DST^) and (x or SRC^));
    psw := psw and not NZVC_bit;
    if y and $8000 <> 0 then psw := psw or C_bit
    else if y and $4000 <> 0 then psw := psw or V_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_CMP := nil;
  end {Make_CMP};


  function Make_BIT : pointer;		{ 03SSDD  ++0-    BIT     ------ }
  var
    SRC, DST: ptrw;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(smallint(SRC^ and DST^)));
    Make_BIT := nil;
  end {Make_BIT};


  function Make_BIC : pointer;		{ 04SSDD  ++0-    BIC     ------ }
  var
    SRC, DST: ptrw;
    x: word;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ and not SRC^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_BIC := nil;
  end {Make_BIC};


  function Make_BIS : pointer;		{ 05SSDD  ++0-    BIS     ------ }
  var
    SRC, DST: ptrw;
    x: word;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ or SRC^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_BIS := nil;
  end {Make_BIS};


  function Make_ADD : pointer;		{ 06SSDD  ++++    ADD     ------ }
  var
    SRC, DST: ptrw;
    x, y: word;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ + SRC^;
    y := (DST^ and SRC^) or ((not x) and (DST^ or SRC^));
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZVC_bit;
    if y and $8000 <> 0 then psw := psw or C_bit
    else if y and $4000 <> 0 then psw := psw or V_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_ADD := nil;
  end {Make_ADD};


  function Make_MUL : pointer;		{ 070RSS  ++0+    MUL     ------ }
  var
    SRC: ptrw;
    R: word;
    L: integer;		{ must be signed 32-bit }
  begin
    R := (code shr 5) and $E;
    SRC := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    L := integer(ptrw(@reg[R])^) * integer(SRC^);
    psw := psw and not NZVC_bit;
    Check_Bit_NZ(L);
{ C set if low word overflows }
    if (L>65535) or (L<-65536) then psw := psw or C_bit;
    ptrw(@reg[R])^ := ptrw(PChar(@L)+2)^;	{ most significant word }
    ptrw(@reg[R or 2])^ := word(L);		{ least significant word }
    Make_MUL := nil;
  end {Make_MUL};


  function Make_DIV : pointer;		{ 071RSS  ++++    DIV     ------ }
  var
    SRC: ptrw;
    R: word;
    L: integer;		{ must be signed 32-bit }
  begin
    R := (code shr 5) and $E;
    SRC := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    psw := psw and not NZVC_bit;
    if SRC^ = 0 then psw := psw or V_bit or C_bit
    else
    begin
      ptrw(PChar(@L)+2)^ := ptrw(@reg[R])^;	{ most significant word }
      ptrw(@L)^ := ptrw(@reg[R or 2])^;		{ least significant word }
      ptrw(@reg[R or 2])^ := word(L mod integer(SRC^));	{ remainder }
      L := L div integer(SRC^);
      ptrw(@reg[R])^ := word(L);		{ quotient }
      Check_Bit_NZ(L);
      if (L>65535) or (L<-65536) then psw := psw or V_bit;
    end;
    Make_DIV := nil;
  end {Make_DIV};


  function Make_ASH : pointer;		{ 072RSS  ++++    ASH     ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_ASH := @rom[$0008];
  end {Make_ASH};


  function Make_ASHC : pointer;		{ 073RSS  ++++    ASHC    ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_ASHC := @rom[$0008];
  end {Make_ASHC};


  function Make_XOR : pointer;		{ 074RDD  ++0-    XOR     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    x := (code shr 5) and $E;		{ index of the R register }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ xor ptrw(@reg[x])^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_XOR := nil;
  end {Make_XOR};


  function Make_SOB : pointer;		{ 077RNN  ----    SOB     ------ }
  var
    DST: ptrw;
  begin
    DST := ptrw(@reg[(code shr 5) and $E]);
    DST^ := DST^ - 1;
    if DST^ <> 0 then
	ptrw(@reg[R7])^ := ptrw(@reg[R7])^ - ((code shl 1) and $7E);
    Make_SOB := nil;
  end {Make_SOB};


  function Make_EMT : pointer;		{ 1040XXX ++++    EMT     ------ }
  begin
    Make_EMT := @rom[$0018];
  end {Make_EMT};


  function Make_TRAP : pointer;		{ 1044XXX ++++    TRAP    ------ }
  begin
    Make_TRAP := @rom[$001C];
  end {Make_TRAP};


  function Make_MOVB : pointer;		{ 11SSDD  ++0-    MOVB    ------ }
  var
    SRC, DST: ptrb;
  begin
    SRC := ptrb(GetSrcB((code shr 6) and $3F));
{ here should go the 'loc' range check }
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    if (code and $38) <> 0 then
    begin
      DST := ptrb(DstPtr);
      DST^ := SRC^;
    end
{ if DST is a register, is sign-extended }
    else ptrsmall(DST)^ := smallint(shortint(SRC^));
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(shortint(DST^)));
    Make_MOVB := nil;
  end {Make_MOVB};


  function Make_CMPB : pointer;		{ 12SSDD  ++++    CMPB    ------ }
  var
    SRC, DST: ptrb;
    x, y: byte;
  begin
{ different order from SUB! }
    DST := ptrb(GetSrcB((code shr 6) and $3F));
{ here should go the 'loc' range check }
    SRC := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^ - SRC^;
    y := (x and SRC^) or ((not DST^) and (x or SRC^));
    psw := psw and not NZVC_bit;
    if y and $80 <> 0 then psw := psw or C_bit
    else if y and $40 <> 0 then psw := psw or V_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_CMPB := nil;
  end {Make_CMPB};


  function Make_BITB : pointer;		{ 13SSDD  ++0-    BITB    ------ }
  var
    SRC, DST: ptrb;
  begin
    SRC := ptrb(GetSrcB((code shr 6) and $3F));
{ here should go the 'loc' range check }
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(shortint(SRC^ and DST^)));
    Make_BITB := nil;
  end {Make_BITB};


  function Make_BICB : pointer;		{ 14SSDD  ++0-    BICB    ------ }
  var
    SRC, DST: ptrb;
    x: byte;
  begin
    SRC := ptrb(GetSrcB((code shr 6) and $3F));
{ here should go the 'loc' range check }
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^ and not SRC^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_BICB := nil;
  end {Make_BICB};


  function Make_BISB : pointer;		{ 15SSDD  ++0-    BISB    ------ }
  var
    SRC, DST: ptrb;
    x: byte;
  begin
    SRC := ptrb(GetSrcB((code shr 6) and $3F));
{ here should go the 'loc' range check }
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^ or SRC^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_BISB := nil;
  end {Make_BISB};


  function Make_SUB : pointer;		{ 16SSDD  ++++    SUB     ------ }
  var
    SRC, DST: ptrw;
    x, y: word;
  begin
    SRC := ptrw(GetSrcW((code shr 6) and $3F));
{ here should go the 'loc' range and parity check }
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ - SRC^;
    y := (x and SRC^) or ((not DST^) and (x or SRC^));
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZVC_bit;
    if y and $8000 <> 0 then psw := psw or C_bit
    else if y and $4000 <> 0 then psw := psw or V_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_SUB := nil;
  end {Make_SUB};


  function Make_HALT : pointer;		{ 000000  ----    HALT    ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_HALT := @rom[$0008];
  end {Make_HALT};


  function Make_WAIT : pointer;		{ 000001  ----    WAIT    ------ }
{ to be implemented when supported by the MK-85 CPU,
  the MK-85 firmware seems to use BIC #0400,@#104 instead }
  begin
    Make_WAIT := @rom[$0008];
  end {Make_WAIT};


  function Make_RTI : pointer;		{ 000002  ++++    RTI     ------ }
{ the MK-85 CPU has an alternate, undocumented RTI command, code 000012 }
  var
    stack: pointer;
  begin
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    ptrw(@reg[R7])^ := ptrw(stack)^;		{ PC <- (stack) }
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    psw := ptrw(stack)^;        		{ PC <- (stack) }
{    T_flag := (psw and T_bit) <> 0; }
    Make_RTI := nil;
  end {Make_RTI};


  function Make_BPT : pointer;		{ 000003  ++++    BPT     ------ }
  begin
    Make_BPT := @rom[$000C];
  end {Make_BPT};


  function Make_IOT : pointer;		{ 000004  ++++    IOT     ------ }
  begin
    Make_IOT := @rom[$0010];
  end {Make_IOT};


  function Make_RESET : pointer;	{ 000005  0000    RESET   ------ }
  begin
    Make_RESET := nil;
  end {Make_RESET};


  function Make_RTT : pointer;		{ 000006  ++++    RTT     ------ }
  var
    stack: pointer;
  begin
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    ptrw(@reg[R7])^ := ptrw(stack)^;		{ PC <- (stack) }
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    psw := ptrw(stack)^;        		{ PC <- (stack) }
{    T_flag := False; }
    Make_RTT := nil;
  end {Make_RTT};


  function Make_MFPT : pointer;		{ 000007  ----    MFPT    ------ }
  begin
    Make_MFPT := @rom[$0008];
  end {Make_MFPT};


  function Make_RTI12 : pointer;	{ 000012  ++++    RTI12   ------ }
{ it's an undocumented 'return from interrupt' command }
  var
    stack: pointer;
  begin
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    ptrw(@reg[R7])^ := ptrw(stack)^;		{ PC <- (stack) }
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    psw := ptrw(stack)^;        		{ PC <- (stack) }
{    T_flag := (psw and T_bit) <> 0; }
    Make_RTI12 := nil;
  end {Make_RTI12};


  function Make_JMP : pointer;		{ 0001SS  ----    JMP     ------ }
{ The destination of JMP must not be a register, i.e. the address mode must
  not equal zero. If it does, a trap at 10 occurs. }
  begin
    if (code and $38) = 0 then Make_JMP := @rom[$0008] else
    begin
      dummyptr := GetSrcW(code and $3F);
      ptrw(@reg[R7])^ := loc;
      Make_JMP := nil;
    end;
  end {Make_JMP};


  function Make_RTS : pointer;		{ 00020R  ----    RTS     ------ }
  var
    R: word;
    stack: pointer;
  begin
    R := (code shl 1) and $E;   		{ index of the R register }
    ptrw(@reg[R7])^ := ptrw(@reg[R])^;		{ PC <- R }
    stack := GetSrcW($16);			{ stack <- SP, SP <- SP+2 }
{ here should go the 'loc' range check }
    ptrw(@reg[R])^ := ptrw(stack)^;		{ R <- (stack) }
    Make_RTS := nil;
  end {Make_RTS};


  function Make_CLC : pointer;		{ 00024C  ++++    CLC     ------ }
  begin
    psw := psw and not (code and $F);
    Make_CLC := nil;
  end {Make_CLC};


  function Make_SEC : pointer;		{ 00026C  ++++    SEC     ------ }
  begin
    psw := psw or (code and $F);
    Make_SEC := nil;
  end {Make_SEC};


  function Make_SWAB : pointer;		{ 0003DD  ++00    SWAB    ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := Swap(DST^);
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := psw and not NZVC_bit;
    Check_Bit_NZ(integer(shortint(Lo(x))));	{ N,Z according to low byte of the result }
    Make_SWAB := nil;
  end {Make_SWAB};


  function Make_CLR : pointer;		{ 0050DD  0100    CLR     ------ }
  var
    DST: ptrw;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := 0;
    psw := (psw and not NZVC_bit) or Z_bit;
    Make_CLR := nil;
  end {Make_CLR};


  function Make_COM : pointer;		{ 0051DD  ++01    COM     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := not DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    DST^ := x;
    psw := (psw and not NZV_bit) or C_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_COM := nil;
  end {Make_COM};


  function Make_INC : pointer;		{ 0052DD  +++-    INC     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ + 1;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    psw := psw and not NZV_bit;
    if x = $8000 then psw := psw or V_bit;
    DST^ := x;
    Check_Bit_NZ(integer(smallint(x)));
    Make_INC := nil;
  end {Make_INC};


  function Make_DEC : pointer;		{ 0053DD  +++-    DEC     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^ - 1;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    psw := psw and not NZV_bit;
    if DST^ = $7FFF then psw := psw or V_bit;
    DST^ := x;
    Check_Bit_NZ(integer(smallint(x)));
    Make_DEC := nil;
  end {Make_DEC};


  function Make_NEG : pointer;		{ 0054DD  ++++    NEG     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    psw := psw and not NZVC_bit;
    if x = $8000 then psw := psw or V_bit;
    DST^ := -x;
    if DST^ <> 0 then psw := psw or C_bit;
    Check_Bit_NZ(integer(smallint(DST^)));
    Make_NEG := nil;
  end {Make_NEG};


  function Make_ADC : pointer;		{ 0055DD  ++++    ADC     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    psw := psw and not NZV_bit;
    if (psw and C_bit) <> 0 then
    begin
      if x = $7FFF then psw := psw or V_bit;
      if x <> $FFFF then psw := psw and not C_bit;
      x := x + 1;
    end;
    DST^ := x;
    Check_Bit_NZ(integer(smallint(x)));
    Make_ADC := nil;
  end {Make_ADC};


  function Make_SBC : pointer;		{ 0056DD  ++++    SBC     ------ }
  var
    DST: ptrw;
    x: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    psw := psw and not NZV_bit;
    if (psw and C_bit) <> 0 then
    begin
      if x = $8000 then psw := psw or V_bit;
      if x <> 0 then psw := psw and not C_bit;
      x := x - 1;
    end;
    DST^ := x;
    Check_Bit_NZ(integer(smallint(x)));
    Make_SBC := nil;
  end {Make_SBC};


  function Make_TST : pointer;		{ 0057DD  ++00    TST     ------ }
  var
    x: word;
  begin
    x := ptrw(GetSrcW(code and $3F))^;
{ here should go the 'loc' range and parity check }
    psw := psw and not NZVC_bit;
    Check_Bit_NZ(integer(smallint(x)));
    Make_TST := nil;
  end {Make_TST};


  function Make_ROR : pointer;		{ 0060DD  ++++    ROR     ------ }
  var
    DST: ptrw;
    x, C1: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    C1 := x and 1;
    x := x shr 1;
    if (psw and C_bit) <> 0 then x := x or $8000;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(smallint(x)));
    NCtoV;
    Make_ROR := nil;
  end {Make_ROR};


  function Make_ROL : pointer;		{ 0061DD  ++++    ROL     ------ }
  var
    DST: ptrw;
    x, C1: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    if (x and $8000) = 0 then C1 := 0 else C1 := 1;
    x := x shl 1;
    if (psw and C_bit) <> 0 then x := x or 1;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(smallint(x)));
    NCtoV;
    Make_ROL := nil;
  end {Make_ROL};


  function Make_ASR : pointer;		{ 0062DD  ++++    ASR     ------ }
  var
    DST: ptrw;
    x, C1: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    C1 := x and 1;
    x := (x and $8000) or (x shr 1);
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(smallint(x)));
    NCtoV;
    Make_ASR := nil;
  end {Make_ASR};


  function Make_ASL : pointer;		{ 0063DD  ++++    ASL     ------ }
  var
    DST: ptrw;
    x, C1: word;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    if (x and $8000) = 0 then C1 := 0 else C1 := C_bit;
    x := x shl 1;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(smallint(x)));
    NCtoV;
    Make_ASL := nil;
  end {Make_ASL};


  function Make_MARK : pointer;		{ 0064NN  ----    MARK    ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_MARK := @rom[$0008];
  end {Make_MARK};


  function Make_SXT : pointer;		{ 0067DD  ?+?-    SXT     ------ }
{ different documents vary in description how this instruction affects the
  N, V status bits }
  var
    DST: ptrw;
  begin
    DST := ptrw(GetSrcW(code and $3F));
{ here should go the 'loc' range and parity check }
    if (code and $38) <> 0 then DST := ptrw(DstPtr);
    if (psw and N_bit) = 0 then
    begin
      DST^ := 0;
      psw := psw or Z_bit;
    end
    else
    begin
      DST^ := $FFFF;
      psw := psw and not Z_bit;
    end;
    Make_SXT := nil;
  end {Make_SXT};


  function Make_CLRB : pointer;		{ 1050DD  0100    CLRB    ------ }
  var
    DST: ptrb;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := 0;
    psw := (psw and not NZVC_bit) or Z_bit;
    Make_CLRB := nil;
  end {Make_CLRB};


  function Make_COMB : pointer;		{ 1051DD  ++01    COMB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := not DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := x;
    psw := (psw and not NZV_bit) or C_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_COMB := nil;
  end {Make_COMB};


  function Make_INCB : pointer;		{ 1052DD  +++-    INCB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^ + 1;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    if x = $80 then psw := psw or V_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_INCB := nil;
  end {Make_INCB};


  function Make_DECB : pointer;		{ 1053DD  +++-    DECB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^ - 1;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    DST^ := x;
    psw := psw and not NZV_bit;
    if x = $7F then psw := psw or V_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_DECB := nil;
  end {Make_DECB};


  function Make_NEGB : pointer;		{ 1054DD  ++++    NEGB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    psw := psw and not NZVC_bit;
    if x = $80 then psw := psw or V_bit;
    DST^ := -x;
    if DST^ <> 0 then psw := psw or C_bit;
    Check_Bit_NZ(integer(shortint(DST^)));
    Make_NEGB := nil;
  end {Make_NEGB};


  function Make_ADCB : pointer;		{ 1055DD  ++++    ADCB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    psw := psw and not NZV_bit;
    if (psw and C_bit) <> 0 then
    begin
      if x = $7F then psw := psw or V_bit;
      if x <> $FF then psw := psw and not C_bit;
      x := x + 1;
    end;
    DST^ := x;
    Check_Bit_NZ(integer(shortint(x)));
    Make_ADCB := nil;
  end {Make_ADCB};


  function Make_SBCB : pointer;		{ 1056DD  ++++    SBCB    ------ }
  var
    DST: ptrb;
    x: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    psw := psw and not NZV_bit;
    if (psw and C_bit) <> 0 then
    begin
      if x = $80 then psw := psw or V_bit;
      if x <> 0 then psw := psw and not C_bit;
      x := x - 1;
    end;
    DST^ := x;
    Check_Bit_NZ(integer(shortint(x)));
    Make_SBCB := nil;
  end {Make_SBCB};


  function Make_TSTB : pointer;		{ 1057DD  ++00    TSTB    ------ }
  var
    x: byte;
  begin
    x := ptrb(GetSrcB(code and $3F))^;
{ here should go the 'loc' range check }
    psw := psw and not NZVC_bit;
    Check_Bit_NZ(integer(shortint(x)));
    Make_TSTB := nil;
  end {Make_TSTB};


  function Make_RORB : pointer;		{ 1060DD  ++++    RORB    ------ }
  var
    DST: ptrb;
    x, C1: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    C1 := x and 1;
    x := x shr 1;
    if (psw and C_bit) <> 0 then x := x or $80;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(shortint(x)));
    NCtoV;
    Make_RORB := nil;
  end {Make_RORB};


  function Make_ROLB : pointer;		{ 1061DD  ++++    ROLB    ------ }
  var
    DST: ptrb;
    x, C1: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    if (x and $80) = 0 then C1 := 0 else C1 := C_bit;
    x := x shl 1;
    if (psw and C_bit) <> 0 then x := x or 1;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(shortint(x)));
    NCtoV;
    Make_ROLB := nil;
  end {Make_ROLB};


  function Make_ASRB : pointer;		{ 1062DD  ++++    ASRB    ------ }
  var
    DST: ptrb;
    x, C1: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    C1 := x and 1;
    x := (x and $80) or (x shr 1);
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(shortint(x)));
    NCtoV;
    Make_ASRB := nil;
  end {Make_ASRB};


  function Make_ASLB : pointer;		{ 1063DD  ++++    ASLB    ------ }
  var
    DST: ptrb;
    x, C1: byte;
  begin
    DST := ptrb(GetSrcB(code and $3F));
{ here should go the 'loc' range check }
    x := DST^;
    if (code and $38) <> 0 then DST := ptrb(DstPtr);
    if (x and $80) = 0 then C1 := 0 else C1 := C_bit;
    x := x shl 1;
    DST^ := x;
    psw := (psw and not NZVC_bit) or C1;
    Check_Bit_NZ(integer(shortint(x)));
    NCtoV;
    Make_ASLB := nil;
  end {Make_ASLB};


  function Make_MTPS : pointer;		{ 1064SS  ++++    MTPS    ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_MTPS := @rom[$0008];
  end {Make_MTPS};


  function Make_MFPS : pointer;		{ 1067DD  ----    MFPS    ------ }
{ to be implemented when supported by the MK-85 CPU }
  begin
    Make_MFPS := @rom[$0008];
  end {Make_MFPS};


end.
